package redSocialGrupos;

import java.awt.Color;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class Cluster implements Comparable {
	private List<RedSocialNodo> nodos;
	private Vector mean;
	public long ID;
	public Color C;
	private Vector sum; 
	

	public Cluster(int vectorsSize, long id){
		this.nodos = new ArrayList<RedSocialNodo>();
		sum = new Vector(new double[vectorsSize]);
		this.ID=id;
		this.C=new Color((int)(Math.random()*255), (int)(Math.random()*255), (int)(Math.random()*255));
	}
	
	public void setMean(RedSocialNodo meanNode){
		this.mean = new Vector(meanNode.getCoordenadas().data.clone());
	}
	
	public void addNodo(RedSocialNodo nodo) {
		nodo.setColor(this.C);
		nodo.setCluster(this);
		nodos.add(nodo);
		Vector vector=nodo.getCoordenadas();
		for(int i=0; i < vector.data.length; i++){
			sum.data[i] += vector.data[i];
		}
	}
	
	public Vector getmean() {
		return mean;
	}
	
	public String toString(){
		StringBuffer buffer = new StringBuffer();
		if(nodos.size() >=1){
			for(RedSocialNodo nodo : nodos){
				buffer.append("Id:"+nodo.getWho()+"---[");
				buffer.append(nodo.getCoordenadas().toString());
				buffer.append("]");
			}
		}
		return buffer.toString();
	}
	
	public void recomputeClusterMean() {
		for(int i=0; i < sum.data.length; i++){
			mean.data[i] = sum.data[i] / nodos.size();
		}
	}

	public List<RedSocialNodo> getNodos(){
		return nodos;
	}

	public int compareTo(Object arg0) {
		Cluster otro=(Cluster)arg0;
		
		int dev=otro.getNodos().size()-this.getNodos().size();
		
		if(dev==0){
			if(otro.ID>this.ID)
				dev=1;
			else
				dev=-1;
		}
		
		return dev;
	}
	
	public boolean equals(Object o){
		Cluster c=(Cluster)o;
		
		return this.ID==c.ID;
	}
	
	public void cambiarID(Cluster c){
		this.ID=c.ID;
		this.C=c.C;
		
		for(int i=0; i<nodos.size(); i++){
			RedSocialNodo ni=nodos.get(i);
			
			ni.setColor(this.C);
		}
	}
	
	public double distanciaCluster(Cluster c){
 		double ds=0;
 		  
  		for(int i=0; i<mean.data.length; i++){
  			ds+=Math.pow((mean.data[i]-c.mean.data[i]), 2);
  		}
  		
  		ds=Math.sqrt(ds);
	  
  		return ds;	
	}
	
	public void etiquetarNodoRepresentativo(){
		for(int i=0; i<nodos.size(); i++){
			RedSocialNodo nodoi=nodos.get(i);
			
			if(i==0){
				nodoi.setEtiquetaCluster("C"+this.ID+"("+nodos.size()+")");
			}else
				nodoi.setEtiquetaCluster(null);
		}
	}
}
