package redSocialGrupos;

import java.util.List;

import uchicago.src.sim.analysis.OpenSequenceGraph;
import uchicago.src.sim.engine.BasicAction;
import uchicago.src.sim.engine.Schedule;
import uchicago.src.sim.engine.SimModelImpl;
import uchicago.src.sim.engine.SimpleModel;
import uchicago.src.sim.util.SimUtilities;

public abstract class MultiExperimentoSimple extends SimpleModel{
	private int repeticion, repeticionMax;
    protected abstract double getTick();
    protected abstract int getTickMax();
    
    protected abstract void accionFinTanda();
    protected abstract void recogidaDatosHistogramas(Object agente);
    protected abstract void recogidaDatosSeries();
    protected abstract void ultimaAccion();
    
    
    public int getRepeticion() {
		return repeticion;
	}
    
	public void setRepeticion(int repeticion) {
		this.repeticion = repeticion;
		
		if(repeticion<repeticionMax)
			repeticionMax=repeticion;
	}
	
	public int getRepeticionMax(){
		return this.repeticionMax;
	}
	
	public void setFin(int fin) {
		if(fin>0){
			ultimaAccion();
			getController().exitSim();
		}
		
		this.repeticion = repeticion;
	}
	

    protected void defaultStep(){
    	if(getTick()>=getTickMax()){
        	for(int i =0; i < agentList.size(); i++){
        		recogidaDatosHistogramas(agentList.get(i));	
        	}
    	}
            			
        recogidaDatosSeries();	
       
    	if(getTick()>=getTickMax()){	    
    		
          if(getRepeticion()>=0)
        	  accionFinTanda();
              
    	  getController().stopSim();
      	}
    }
}
