package redSocialGrupos;

import java.awt.Color;

import uchicago.src.sim.gui.DrawableEdge;
import uchicago.src.sim.gui.SimGraphics;
import uchicago.src.sim.network.DefaultEdge;
import uchicago.src.sim.network.Node;



public class RedSocialArista extends DefaultEdge implements DrawableEdge {
	private Color color;
	private RedSocialNodo agenteOrigen, agenteDestino;
  
	public RedSocialArista() {}

	public RedSocialArista(RedSocialNodo from, RedSocialNodo to, Color color, int tipo) {
		super(from, to, "");
		agenteOrigen=from;
		agenteDestino=to;
		this.color = color;
	}
  
	public RedSocialArista(RedSocialNodo from, RedSocialNodo to) {
		super(from, to, "");
	    agenteOrigen=from;
	    agenteDestino=to;
	    this.color = Color.yellow;
	}
   
	public void setColor(Color c) {
		color = c;
	}

	public void draw(SimGraphics g, int fromX, int toX, int fromY, int toY) {
		g.drawDirectedLink(color, fromX, toX, fromY, toY);
	}
  
	public boolean equals(Object o){
		RedSocialArista otraArista=(RedSocialArista)o;
	  
		return (this.getFrom()==otraArista.getFrom() && this.getTo()==otraArista.getTo()) || (this.getFrom()==otraArista.getTo() && this.getTo()==otraArista.getFrom());
	}
  
	public RedSocialNodo getAgenteOrigen(){ return agenteOrigen;}
	public RedSocialNodo getAgenteDestino(){ return agenteDestino;}
}
